#include "GRAPH.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

Edge EDGE(unsigned int v, unsigned int w)
{
  Edge e;
  e.v = v;
  e.w = w;
  return e;
}

unsigned int randV(Graph G)
{
  return G->V * (rand() / (RAND_MAX + 1.0));
}

Graph GRAPHrand(unsigned int V, unsigned int E)
{
  Graph G = GRAPHinit(V);
  if(E > V*(V-1)/2)
    {
      fprintf(stderr,"ERRO: Excesso de Arestas\nDefinindo como maximo.\n");
      E = V*(V-1)/2;      
    }
  while(G->E < E)
    GRAPHinsertE(G, EDGE(randV(G), randV(G)));
  return G;
}


/*le um grafo pela representacao de listas de adjacencias
*/
Graph GRAPHread(unsigned int V)
{
  
  unsigned int i, v, w;
  char c;
  link t, x;
  Graph G = GRAPHinit(V);
  for(i = 0; i < V; i++)
    {
      scanf("%u:",&v);
      t = NULL;
      while(1)
	{
	  c = getchar();
	  if(c != '\n' && c >= 0)
	    ungetc(c,stdin);
	  else
	    break;
	  scanf("%u",&w);
          x = malloc(sizeof *x);
	  x->v = w; x->next = NULL;
	  if(t)
	    {
	      t->next = x;
	      t = t->next;
	    }
	  else
	    {
	      G->adj[v] = x;
	      t = G->adj[v];
	    }
	}
    }
  return G;
}

char **pilha;
int topo;

int insere(char *s)
{
  int i;
  for(i = 0; i < topo; i++)
    if(strcmp(s,pilha[i]) == 0)
      return i;
  pilha[topo] = malloc(100);
  strcpy(pilha[topo],s);
  topo++;
  return topo-1;
}

Graph GRAPHreadstring(unsigned int V)
{  
  char string[100];
  unsigned int i, v, w;
  link t, x;
  Graph G = GRAPHinit(V);
  topo = 0;
  pilha = malloc(V*sizeof(char *)+10);
  for(i = 0; i < V; i++)
    {
      scanf("%[^\n]",string);
      getchar();
      v = insere(string);
      t = NULL;
      while(scanf("  -> %[^\n]",string)>0)
	{
	  getchar();
	  w = insere(string);
          x = malloc(sizeof *x);
	  x->v = w; x->next = NULL;
	  if(t)
	    {
	      t->next = x;
	      t = t->next;
	    }
	  else
	    {
	      G->adj[v] = x;
	      t = G->adj[v];
	    }
	}
    }
  return G;
}

void imprime_v(int i)
{
  printf("%d ",i);
  /*  printf("  ->%s\n",pilha[i]);*/
}

void GRAPHprint(Graph G)
{
  int v;
  link t;
  printf("\n");
  for(v = 0; v < G->V; v++)
    {
      printf("%d: ",v);
      for(t = G->adj[v]; t != NULL; t = t->next)
	{
	  printf("%d ", t->v);
	}
      printf("\n");
    }
}
