#include "GRAPH.h"
#include "graph-common.h"
#include "strong-comp.h"
#include <stdio.h>
#include <stdlib.h>

static int post[maxV], postR[maxV], sc[maxV], hist[maxV];
static int cnt0, cnt1;
/*implementacao do Sedgewick*/
void SCdfsR(Graph G, int w, int show)
{
  link t;
  sc[w] = cnt1;
  hist[cnt1]++;
  if(show) /*mostra o vertice*/
    printf("%d ",w);
  for(t = G->adj[w]; t!= NULL; t = t->next)
    if(sc[t->v] == -1) 
      SCdfsR(G, t->v,show);
  post[cnt0++] = w;
}

void GRAPHsc(Graph G, int show)
{
  int v; 
  Graph R;
  R = GRAPHreverse(G);
  cnt0 = 0; cnt1 = 0;
  for(v = 0; v < G->V; v++) 
    sc[v] = -1;
  for(v = 0; v < G->V; v++)
    if(sc[v] == -1) 
      SCdfsR(R,v,0);/*essa chamada nao mostra o vertice independente
		      de show*/
  cnt0 = 0; 
  cnt1 = 0;
  for (v = 0; v < G->V; v++) 
    sc[v] = -1;
  for (v = 0; v < G->V; v++) 
    postR[v] = post[v];
  
  for (v = 0; v < G->V; v++)/*limpa o vetor de tamanhos dos componentes*/
    hist[v] = 0;

  if(show)
    printf("Componentes fortemente conexos:\n");
  for (v = G->V-1; v >= 0; v--)
    if (sc[postR[v]] == -1)
      {
	SCdfsR(G, postR[v],show); 
	cnt1++;
	if(show)/*terminou um componente, deve imprimir quebra de linha*/
	  printf("\n");
      }
  /*ordena e imprime os tamanhos*/
  qsort(hist,cnt1,sizeof(int),decrescente);
  printf("Tamanho dos componentes fortemente conexos:\n");
  for(v = 0; v < cnt1; v++)
    printf("%d\n",hist[v]);

  GRAPHdestroy(R);
}

