#include "GRAPH.h"
#include "graph-common.h"
#include "strong-comp.h"
#include <stdlib.h>
#include <stdio.h>

int pre[maxV], low[maxV], s[maxV],sc[maxV], N = 0, hist[maxV];

/*implementacao igual ao do Sedgewick*/
int cnt0, cnt1;
void SCdfsR(Graph G, int w, int show)
{
  link t; int v, min;
  pre[w] = cnt0++;
  low[w] = pre[w];
  min = low[w];
  s[N++] = w;
  for(t = G->adj[w]; t != NULL; t = t->next)
    {
      if (pre[t->v] == -1)
	SCdfsR(G, t->v,show);
      if (low[t->v] < min)
	min = low[t->v];
    }
  if( min < low[w] )
    {
      low[w] = min; 
      return;
    }
  do
    {
      sc[(v = s[--N])] = cnt1;
      /*como esta desempilhando, mostra o vertice se desejado e
	aumenta o tamanho do componente atual*/
      hist[cnt1]++;
      if(show)
	printf("%d ",s[N]);
      low[v] = G->V;       
    }
  while(s[N] != w);
  cnt1++;
  if(show)/*acabou este componente*/
    printf("\n");
}

void GRAPHsc(Graph G, int show)
{
  int v;
  /*limpa os vetores*/
  for(v = 0; v < G->V; v++)
    {
     hist[v] = 0;
     pre[v] = -1;
    }
  if(show)
    printf("Componentes fortemente conexos:\n");
  for(v = 0; v < G->V; v++)
    if(pre[v] == -1)
      SCdfsR(G,v,show);
  /*ordena e mostra os tamanhos*/
  qsort(hist,cnt1,sizeof(int),decrescente);
  printf("Tamanho dos componentes fortemente conexos:\n");
  for(v = 0; v < cnt1; v++)
    printf("%d\n",hist[v]);

}
